import hashlib

def check_credentials(user_id, merchant_id, merchant_name, merchant_password):
    if not all([user_id, merchant_id, merchant_name, merchant_password]):
        message = 'Please set `user_id`, `merchant_id`, `merchant_name`, and `merchant_password`.'
        raise UnboundLocalError(message)
    else:
        return True

def hash_pasword(signature):
    """
        Fungsi untuk meng-hash signature sesuai dengan ketentuan dari Faspay.
    """
    key = ''
    for s in signature:
        key += str(s)

    md5_signature = hashlib.md5(key.encode('utf-8')).hexdigest()
    sha1_signature = hashlib.sha1(md5_signature.encode('utf-8')).hexdigest()
    return sha1_signature

def check_required_fields(required_fields, exist_fields):
    for field in required_fields:
        if field not in exist_fields:
            raise KeyError('Field `%s` is required!' % field)